﻿
#TEMP_ERR =    -2000     ; Ошибка при чтении температуры.
#TEMP_NODATA = -2001     ; Нет данных о температуре.

Structure OW_SN ; Идентификатор 1-Wire устройства.
  Type.a         ; Тип устройства (код семейства).
  Number.a[6]    ; Серийный номер.
  CRC.a          ; Контрольная сумма.
EndStructure

Structure BuffA
  Buff.a[0]
EndStructure

Structure BuffW
  Buff.w[0]
EndStructure

Procedure.a GetCRC(*Buff.BuffA, Count)
  Protected CRC.a, Byte.a, i, x
  
  Count-1
  For i=0 To Count
    Byte=*Buff\Buff[i]
    For x=1 To 8
      If (Byte ! CRC) & 1
        CRC = ((CRC!$18)>>1)|$80
      Else
        CRC >> 1
      EndIf
      Byte>>1
    Next x
  Next i
  
  ProcedureReturn CRC
EndProcedure

Procedure.s SN_Text(*x.OW_SN)
  Protected String.s, i
  
  String = RSet(Hex(*x\Type), 2, "0")+"-"
  
  For i=5 To 0 Step -1
    String + RSet(Hex(*x\Number[i]), 2, "0")
  Next i
  
  String + "-"+RSet(Hex(*x\CRC), 2, "0")
  
  ProcedureReturn String
EndProcedure


Procedure ListIcon_AddDev(Gadget, List DevList.OW_SN())
  ;Protected i, Count
  
  ClearGadgetItems(Gadget)
  AddGadgetItem(Gadget, -1, "Встроенный датчик")
  
  ForEach DevList()
    AddGadgetItem(Gadget, -1, SN_Text(@DevList()))
  Next
  
EndProcedure


Procedure ListIcon_AddTemp(Gadget, *Buff.BuffW, Count)
  Protected i
  
  ;Count-1
  For i=0 To Count
    
    If *Buff=0
      Goto m1
    EndIf
    
    If *Buff\Buff[i]>#TEMP_ERR
      SetGadgetItemText(Gadget, i, StrF(*Buff\Buff[i]/10, 1), 1)
    ElseIf *Buff\Buff[i]=#TEMP_ERR
      SetGadgetItemText(Gadget, i, "Ошибка", 1)
    ElseIf *Buff\Buff[i]=#TEMP_NODATA
      SetGadgetItemText(Gadget, i, "Н/Д", 1)
    Else
      m1:
      SetGadgetItemText(Gadget, i, "", 1)
    EndIf
  Next
  
EndProcedure
; IDE Options = PureBasic 5.60 (Windows - x86)
; Folding = -
; EnableXP