#include "stm32f10x_conf.h"
#include "HidDev_Config.h"
#include "usb.h"
#include "main.h"

extern volatile sOW_SN OWireDev[COUNT_OW_DEV];
extern volatile sOW_Temp OWireTemp[COUNT_OW_DEV];
extern volatile uint16_t CountOWireDev;
extern volatile int16_t TempIntSensor;

enum
{
    CMD_GetSensor=1,
    CMD_GetTemp
};

uint8_t SendBuff[64];

void HID_Receive(uint8_t *Buff, uint8_t Size) //      USB.
{

    {
        uint8_t i;
        for (i=0; i<64; i++) SendBuff[i] = 0;
    }

    switch (Buff[0])
    {
    case CMD_GetSensor:
        if (Buff[1]<=(COUNT_OW_DEV/7-1))
        {
            SendBuff[0] = CMD_GetSensor;
            SendBuff[1] = CountOWireDev;

            uint16_t i, x, Pos=8;

            for (i=0; i<7; i++)
            {
               for (x=0; x<8; x++)
               {
                   SendBuff[Pos] = OWireDev[Buff[1]+i].SN[x];
                   Pos++;
               }
            }
        }
      break;

    case CMD_GetTemp:
        SendBuff[0] = CMD_GetTemp;

        (*(int16_t*) &SendBuff[2]) = TempIntSensor;

        uint16_t i;

        for (i=0; i<CountOWireDev; i++)
        {
            int16_t Temp = (*((uint16_t*) &OWireTemp[i].L_Termo));

            if (Temp > TEMP_ERR)
            {
                if (OWireDev[i].Type == 0x10) // DS1820 / DS18S20.
                    Temp = Temp * 10 / 2;
                else if (OWireDev[i].Type == 0x28) // DS18B20.
                    Temp = Temp * 10 / 16;
            }

           (*(int16_t*) &SendBuff[i*2+4]) = Temp;
        }

        break;

    default:
      break;
    }

    HID_SendBuff(SendBuff, 64);
}
